Part Module

From FreeCAD Documentation
Jump to: navigation, search
This page contains changes which are not marked for translation.

Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎hrvatski • ‎Bahasa Indonesia • ‎italiano • ‎日本語 • ‎polski • ‎português • ‎português do Brasil • ‎română • ‎русский • ‎svenska • ‎Türkçe • ‎українська • ‎中文 • ‎中文(中国大陆)‎ • ‎中文(台灣)‎

Workbench Part.svg

Introduction

The solid modelling capabilities of FreeCAD are based on the Open Cascade Technology (OCCT) kernel, a professional-grade CAD system that features advanced 3D geometry creation and manipulation.

The Part Workbench allows the user to access and use the OCCT objects and functions. Part objects, unlike Mesh objects, are more complex, and therefore permit more advanced operations like coherent boolean operations, modifications history, and parametric behaviour.

Part example.jpg

Tools

The tools are all located in the Part menu.

Primitives

These are tools for creating primitive objects.

  • Part Box.png Box: Draws a box by specifying its dimensions
  • Part Cone.png Cone: Draws a cone by specifying its dimensions
  • Part Cylinder.png Cylinder: Draws a cylinder by specifying its dimensions
  • Part Sphere.png Sphere: Draws a sphere by specifying its dimensions
  • Part Torus.png Torus: Draws a torus (ring) by specifying its dimensions
  • Part CreatePrimitives.png CreatePrimitives: A tool to create various parametric geometric primitives
  • Part Shapebuilder.png Shapebuilder: A tool to create more complex shapes from various parametric geometric primitives

Modifying objects

These are tools for modifying existing objects. They will allow you to choose which object to modify.

  • Part Booleans.png Booleans: Performs boolean operations on objects
  • Part Union.png Union: Fuses (unions) two objects
  • Part Common.png Common: Extracts the common (intersection) part of two objects
  • Part Cut.png Cut: Cuts (subtracts) one object from another
  • Part JoinConnect.png Join features: smart booleans for walled objects (e.g., pipes) (v0.16)
    • Part JoinConnect.png Connect: Connects interiors of objects (v0.16)
    • Part JoinEmbed.png Embed: Embeds a walled object into another walled object (v0.16)
    • Part JoinCutout.png Cutout: Creates a cutout in a wall of an object for another walled object (v0.16)
  • Splitting tools: (v0.17)
    • Part BooleanFragments.png Boolean fragments: makes all the pieces that can be obtained by Boolean operations between objects (v0.17)
    • Part Slice.png Slice: Splits an object into pieces by intersections with another object (v0.17)
    • Part XOR.png XOR: removes space shared by even number of objects (symmetric version of Cut) (v0.17)
  • Compound
    • Part MakeCompound.png Make compound: Creates a compound from the selected objects.
    • Part CompoundFilter.png Compound Filter: The CompoundFilter can be used to extract the individual pieces.
  • Part Extrude.png Extrude: Extrudes planar faces of an object
  • Part Fillet.png Fillet: Fillets (rounds) edges of an object
  • Part Revolve.png Revolve: Creates a solid by revolving another object (not solid) around an axis
  • Part Section.png Section: Creates a section by intersecting an object with a section plane
  • Part SectionCross.png Cross sections...:
  • Part Chamfer.png Chamfer: Chamfers edges of an object
  • Part Mirror.png Mirror: Mirrors the selected object on a given mirror plane
  • Part RuledSurface.png Ruled Surface:
  • Part Sweep.png Sweep: Sweeps one or more profiles along a path
  • Part Loft.png Loft: Lofts from one profile to another
  • Offset tools:
    • Part Offset.png 3D Offset: Constructs a parallel shape at a certain distance from original.
    • Part Offset2D.png 2D Offset: Constructs a parallel wire at certain distance from original, or enlarges/shrinks a planar face. (v0.17)
    • Part Thickness.png Thickness: Hollows out a solid, leaving openings next to select faces.

Other tools

  • Part ImportCAD.png Import CAD: This tool allows you to add a file *.IGES, *.STEP, *.BREP to the current document.
  • Part ExportCAD.png Export CAD: This tool allows you to export a part object in a *.IGES, *.STEP, *.BREP file.
  • Part ShapeFromMesh.png Shape from Mesh: Creates a shape object from a mesh object.
  • Convert to solid: Converts a shape object to a solid object.
  • Reverse shapes: Flips the normals of all faces of the selected object.
  • Create simple copy: Creates a simple copy of the selected object.
  • Part RefineShape.png Refine shape: Cleans faces by removing unnecessary lines.
  • Part CheckGeometry.png Check geometry: Checks the geometry of selected objects for errors.
  • Measure: Allows linear and angular measurement between points/edges/faces.
Part Boolean example.png

An example of fusion (union), intersection (common) and difference (cut) of solid shapes


Preferences

OCCT geometric concepts

In OpenCascade terminology, we distinguish between geometric primitives and topological shapes. A geometric primitive can be a point, a line, a circle, a plane, etc. or even some more complex types like a B-Spline curve or a surface. A shape can be a vertex, an edge, a wire, a face, a solid or a compound of other shapes. The geometric primitives are not made to be directly displayed on the 3D scene, but rather to be used as building geometry for shapes. For example, an edge can be constructed from a line or from a portion of a circle.

In summary, geometry primitives are "shapeless" building blocks, while topological shapes are the real objects built on them.

A complete list of all primitives and shapes refer to the OCC documentation (Alternative: sourcearchive.com) and search for Geom_* (for geometric primitives) and TopoDS_* (for shapes). There you can also read more about the differences between them. Please note that the official OCC documentation is not available online (you must download an archive) and is mostly aimed at programmers, not at end-users. But hopefully you'll find enough information to get started here.

The geometric types actually can be divided into two major groups: curves and surfaces. Out of the curves (line, circle, ...) you can directly build an edge, out of the surfaces (plane, cylinder, ...) a face can be built. For example, the geometric primitive line is unlimited, i.e. it is defined by a base vector and a direction vector while its shape representation must be something limited by a start and end point. And a box -- a solid -- can be created by six limited planes.

From an edge or face you can also go back to its geometric primitive counterpart.

Thus, out of shapes you can build very complex parts or, the other way round, extract all sub-shapes a more complex shape is made of.

Scripting

The main data structure used in the Part module is the BRep data type from OpenCascade. Almost all contents and object types of the Part module are available by Python scripting. This includes geometric primitives, such as Line and Circle (or Arc), and the whole range of TopoShapes, like Vertexes, Edges, Wires, Faces, Solids and Compounds. For each of those objects, several creation methods exist, and for some of them, especially the TopoShapes, advanced operations like boolean union/difference/intersection are also available. Explore the contents of the Part module, as described in the FreeCAD Scripting Basics page, to know more.

Examples

To create a line element switch to the Python console and type in:

import Part,PartGui 
doc=App.newDocument()  
l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)
doc.addObject("Part::Feature","Line").Shape=l.toShape() 
doc.recompute()

Let's go through the above python example step by step:

import Part,PartGui
doc=App.newDocument()

loads the Part module and creates a new document

l=Part.LineSegment()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)

Line is actually a line segment, hence the start and endpoint.

doc.addObject("Part::Feature","Line").Shape=l.toShape()

This adds a Part object type to the document and assigns the shape representation of the line segment to the 'Shape' property of the added object. It is important to understand here that we used a geometric primitive (the Part.LineSegment) to create a TopoShape out of it (the toShape() method). Only Shapes can be added to the document. In FreeCAD, geometry primitives are used as "building structures" for Shapes.

doc.recompute()

Updates the document. This also prepares the visual representation of the new part object.

Note that a Line Segment can be created by specifying its start and endpoint directly in the constructor, for example Part.LineSegment(point1,point2), or we can create a default line and set its properties afterwards, as we did here.

A circle can be created in a similar way:

import Part
doc = App.activeDocument()
c = Part.Circle() 
c.Radius=10.0  
f = doc.addObject("Part::Feature", "Circle")
f.Shape = c.toShape()
doc.recompute()

Note again, we used the circle (geometry primitive) to construct a shape out of it. We can of course still access our construction geometry afterwards, by doing:

s = f.Shape
e = s.Edges[0]
c = e.Curve

Here we take the shape of our object f, then we take its list of edges. In this case there will be only one because we made the whole shape out of a single circle, so we take only the first item of the Edges list, and we takes its curve. Every Edge has a Curve, which is the geometry primitive it is based on.

Head to the Topological data scripting page if you would like to know more.

Tutorials